#include <windows.h>
#include "runtime.h"
#include "version.h"

void getVersion(VERSION* v)
{
	char name[MAX_PATH + 1];
	char* vi;
	DWORD size;

	GetModuleFileName(NULL, name, MAX_PATH);
	size = GetFileVersionInfoSize(name, 0);
	if(!(vi = halloc(size)))
	{
		v->major = 0;
		v->minor = 0;
		v->patch = 0;
		v->build = 0;

		return;
	}

	GetFileVersionInfo(name, 0, size, vi);
	{
		VS_FIXEDFILEINFO* ver = (VS_FIXEDFILEINFO*)(vi + 40);

		// nameg
		v->major = HIWORD(ver->dwFileVersionMS);
		v->minor = LOWORD(ver->dwFileVersionMS);
		v->patch = HIWORD(ver->dwFileVersionLS);
		v->build = LOWORD(ver->dwFileVersionLS);
	}

	hfree(vi);

	return;
}
